Home Information Classes Download Usage Mail List Requirements Links FAQ Tutorial

# stk::StifKarp Class Reference

STK plucked stiff string instrument. More...

`#include <StifKarp.h>`

Inheritance diagram for stk::StifKarp:

List of all members.

## Public Member Functions
| StifKarp (StkFloat lowestFrequency)
| Class constructor, taking the lowest desired playing frequency.
| ~StifKarp (void)
| Class destructor.
void | clear (void)
| Reset and clear all internal state.
void | setFrequency (StkFloat frequency)
| Set instrument parameters for a particular frequency.
void | setStretch (StkFloat stretch)
| Set the stretch "factor" of the string (0.0 - 1.0).
void | setPickupPosition (StkFloat position)
| Set the pluck or "excitation" position along the string (0.0 - 1.0).
void | setBaseLoopGain (StkFloat aGain)
| Set the base loop gain.
void | pluck (StkFloat amplitude)
| Pluck the string with the given amplitude using the current frequency.
void | noteOn (StkFloat frequency, StkFloat amplitude)
| Start a note with the given frequency and amplitude.
void | noteOff (StkFloat amplitude)
| Stop a note with the given amplitude (speed of decay).
void | controlChange (int number, StkFloat value)
| Perform the control change specified by number and value (0.0 - 128.0).
StkFloat | tick (unsigned int channel=0)
| Compute and return one output sample.

## Detailed Description

STK plucked stiff string instrument.

This class implements a simple plucked string algorithm (Karplus Strong) with enhancements (Jaffe-Smith, Smith, and others), including string stiffness and pluck position controls. The stiffness is modeled with allpass filters.

This is a digital waveguide model, making its use possibly subject to patents held by Stanford University, Yamaha, and others.

Control Change Numbers:

- Pickup Position = 4
- String Sustain = 11
- String Stretch = 1

by Perry R. Cook and Gary P. Scavone, 1995 - 2010.

## Member Function Documentation

void stk::StifKarp::setBaseLoopGain | ( | StkFloat | aGain | ) |

Set the base loop gain.

The actual loop gain is set according to the frequency. Because of high-frequency loop filter roll-off, higher frequency settings have greater loop gains.

The documentation for this class was generated from the following file:

- StifKarp.h

The Synthesis ToolKit in C++ (STK)
©1995-2010 Perry R. Cook and Gary P. Scavone. All Rights Reserved.